//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CPPIndentExpert.h"
#include "EditorIntf.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

TTimer *timer;
int CPPIndentShortCut;
//---------------------------------------------------------------------------

__fastcall TCPPIndentExpert::TCPPIndentExpert(void)
{
  CPPIndentShortCut = TextToShortCut("Ctrl+]");

  CppIndentMenuItem = NULL;

  timer = new TTimer(NULL);
  timer->Enabled = false;       //true;
  timer->Interval = 5000;
  timer->OnTimer = OnTimer;

  char Path[MAX_PATH];
  GetModuleFileName(HInstance, Path, MAX_PATH);
  DllPath = ExtractFilePath(Path);
  if (!FileExists(DllPath + "indent.exe"))
  {                             // indent.exe not in correct path
    AnsiString Msg;
    Msg.sprintf("indent.exe and .indent.pro not found in directory:\n");
    Msg += (DllPath + "\nPlease copy them there.");
    MessageDlg(Msg.c_str(), mtInformation, TMsgDlgButtons() << mbOK, 0);
  }
  else
  {
    OnTimer(NULL);
    timer->Enabled = true;
  }
}

__fastcall TCPPIndentExpert::~TCPPIndentExpert(void)
{
  if (CppIndentMenuItem)
    CppIndentMenuItem->DestroyMenuItem();

  timer->Enabled = false;
  delete timer;
}


void __fastcall TCPPIndentExpert::OnTimer(TObject * Sender)
{
  TIMainMenuIntf *MainMenu;
  TIMenuItemIntf *ReferenceMenuItem;
  TIMenuItemIntf *Menu;

  if (ToolServices)
  {
    MainMenu = ToolServices->GetMainMenu();
    if (MainMenu)
    {                           // then begin { we've got the main menu! }
      ReferenceMenuItem = MainMenu->FindMenuItem("CPPIndent");
      if (ReferenceMenuItem)
      {
        ReferenceMenuItem->SetShortCut(CPPIndentShortCut);
        //MessageDlg("Set ShortCut", mtInformation, TMsgDlgButtons() << mbOK, 0);
        timer->Enabled = false;

        /* ҥHno·Э]@ShortCutAO]sҰBCB6ɡA
           ShortCut|W䧮C
         */
      }
      else
      {
        ReferenceMenuItem = MainMenu->FindMenuItem("EditSelectAll");    //ToolsToolsItem");
        if (ReferenceMenuItem)
        {
          Menu = ReferenceMenuItem->GetParent();
          if (Menu)
          {
            TIMenuFlags MenuFlags;
            CppIndentMenuItem = Menu->InsertItem
              (ReferenceMenuItem->GetIndex() + 1,
               "C++ Indent",
               "CPPIndent",
               "Indent C++ source code",
               CPPIndentShortCut, 0, 0,
               MenuFlags << mfEnabled << mfVisible, CppIndentClick);
          }
        }
      }
    }
  }
}


void __fastcall TCPPIndentExpert::CppIndentClick(TIMenuItemIntf * Sender)
{
  static bool running = false;
  if (running)
    return;
  running = true;

  char TmpFile[MAX_PATH];
  lstrcpy(TmpFile, DllPath.c_str());
  lstrcat(TmpFile, "delete_me.cpp");

  TEditorIntf *EditorIntf = new TEditorIntf();

  for (int idx = 0; idx <= 1; idx++)    // Unit.cpp .hiBz
  {
    int len = EditorIntf->GetTextLen(idx);
    if (len == 0)
      continue;

    char *buffer = new char[len + 1];
    EditorIntf->GetText(idx, buffer);   //, len);
    buffer[len] = 0;

    int iFileHandle = FileCreate(TmpFile);
    FileWrite(iFileHandle, buffer, len);
    FileClose(iFileHandle);

    String indent = DllPath + "indent.exe delete_me.cpp";

    STARTUPINFO StartupInfo;
    ZeroMemory(&StartupInfo, sizeof(STARTUPINFO));
    StartupInfo.cb = sizeof(STARTUPINFO);
    // we are going to set the HIDE-WINDOW flag
    StartupInfo.dwFlags |= STARTF_USESHOWWINDOW;
    StartupInfo.wShowWindow = SW_HIDE;

    PROCESS_INFORMATION ProcessInfo;
    if (CreateProcess(NULL,
                      indent.c_str(),
                      NULL,
                      NULL,
                      TRUE,
                      NORMAL_PRIORITY_CLASS,
                      NULL, DllPath.c_str(), &StartupInfo, &ProcessInfo))
    {
      DWORD dwExitStatus = STILL_ACTIVE;
      // loop until indent closes
      do
      {
        if (!GetExitCodeProcess(ProcessInfo.hProcess, &dwExitStatus))
          break;

        Application->ProcessMessages();
      }
      while (dwExitStatus == STILL_ACTIVE);

      CloseHandle(ProcessInfo.hProcess);
      CloseHandle(ProcessInfo.hThread);
    }
    else
      MessageDlg("Couldn't run Indent.exe", mtInformation,
                 TMsgDlgButtons() << mbOK, 0);

    iFileHandle = FileOpen(TmpFile, fmOpenRead);
    int len2 = FileSeek(iFileHandle, 0, 2);

    char *buffer2 = new char[len2 + 1];
    FileSeek(iFileHandle, 0, 0);
    FileRead(iFileHandle, buffer2, len2);
    buffer2[len2] = 0;

    /** /
    char ss[255];
    wsprintf(ss, "%d %02X %02X %02X %02X %02X %d %02X %02X %02X %02X %02X",
             len, buffer[len - 5], buffer[len - 4], buffer[len - 3],
             buffer[len - 2], buffer[len - 1], len2, buffer2[len2 - 5],
             buffer2[len2 - 4], buffer2[len2 - 3], buffer2[len2 - 2],
             buffer2[len2 - 1]);
    MessageBox(0, ss, "XX", MB_OK);
    /**/

    // IndenteO_ҧ
    int comp = 0;
    if (len != len2 || (comp = lstrcmp(buffer, buffer2)) != 0)
    {
      // Y̥uۮt@ newline NۦP
      if ((comp != 0) || (len - len2 != 2)
          || (buffer[len - 1] != 0x0A) || (buffer[len - 2] != 0x0D))
        EditorIntf->SetText(idx, buffer2, len);

      //String ss = len2;
      //MessageBox(0, ss.c_str(), "XX", MB_OK);
    }

    FileClose(iFileHandle);

    DeleteFile(TmpFile);
    DeleteFile(String(TmpFile) + "~");

    delete buffer;
    delete buffer2;
  }

  delete EditorIntf;
  running = false;
}


AnsiString __stdcall TCPPIndentExpert::GetName()
{
  return "bcbindent";
}

AnsiString __stdcall TCPPIndentExpert::GetAuthor(void)
{
  return "way99";
}

AnsiString __stdcall TCPPIndentExpert::GetComment(void)
{
  return "";
}

AnsiString __stdcall TCPPIndentExpert::GetPage(void)
{
  return "";
}

HICON __stdcall TCPPIndentExpert::GetGlyph(void)
{
  return 0;
}

TExpertStyle __stdcall TCPPIndentExpert::GetStyle(void)
{
  return esAddIn;
}

TExpertState __stdcall TCPPIndentExpert::GetState(void)
{
  TExpertState tx;
  tx << esEnabled;
  return tx;
}

AnsiString __stdcall TCPPIndentExpert::GetIDString(void)
{
  return "BCB.TCPPIndentExpert";
}

AnsiString __stdcall TCPPIndentExpert::GetMenuText(void)
{
  return "";
}

void __stdcall TCPPIndentExpert::Execute(void)
{
}

//---------------------------------------------------------------------------

namespace Bcbindent             // Ĥ@char@wnjgA᪺npg
{
  void __fastcall PACKAGE Register()
  {
    RegisterLibraryExpert(new TCPPIndentExpert());
  }
}
//---------------------------------------------------------------------------

